/*
 * convert.cpp
 *
 *  Created on: Apr 6, 2011
 *      Author: lipari
 */

#include <iostream>
#include <loki/TypeManip.h>
#include <loki/static_check.h>
#include "loki_example.h"

namespace loki_example {
	using namespace Loki;
	using namespace std;

	class A {
	public:
		int	i;
	};

	class B : public A {
	};

	class C : public B {

	};

	class D {
	public:
		int i;
	};

	class E : public A, public D {
	};

#define PRINT(X, Y) \
	cout << #X " <-- " #Y " : " << LOKI_SUPERSUBCLASS(X, Y) << endl

	int convert() {
		PRINT(A, B);
		PRINT(A, C);
		PRINT(B, C);
		PRINT(B, A);
		PRINT(A, D);
		PRINT(D, A);
		PRINT(A, E);
		PRINT(D, E);

		// the following requires that A is a base class of D
		LOKI_STATIC_CHECK(LOKI_SUPERSUBCLASS(A, B), B_Does_Not_Inherith_From_A);
	}
};
