/*
 * tl.h
 *
 *  Created on: Mar 1, 2011
 *      Author: lipari
 */

#ifndef TL_H_
#define TL_H_

class NullType {};

template<typename H, typename T>
struct TypeList {
    typedef H Head;
    typedef T Tail;
};

TypeList<int,
         TypeList<double, NullType>
        > intDoubleVar;
TypeList<int,
         TypeList<double, TypeList<char, NullType> >
        > intDoubleCharVar;

#define TYPELIST_1(t1)             TypeList<t1, NullType>
#define TYPELIST_2(t1, t2)         TypeList<t1, TYPELIST_1(t2) >
#define TYPELIST_3(t1, t2, t3)     TypeList<t1, TYPELIST_2(t2, t3) >
#define TYPELIST_4(t1, t2, t3, t4) TypeList<t1, TYPELIST_3(t2, t3, t4) >

template<typename H, typename T, unsigned index>
struct TypeAt_ {
    typedef typename TypeAt_<typename T::Head, typename T::Tail, index-1>::Result Result;
};

template <typename H, typename T>
struct TypeAt_<H, T, 0> {
    typedef H Result;
};

template <typename H, unsigned index>
struct TypeAt_<H, NullType, index> {
    typedef NullType Result;
};

template <typename H>
struct TypeAt_<H, NullType, 0> {
    typedef H Result;
};

#define TYPEAT(L, index) typename TypeAt_<typename L::Head, \
                                          typename L::Tail, \
                                          index             \
                                         >::Result


template<typename H, typename T>
struct TypeListSize {
   enum { Result = TypeListSize<typename T::Head, typename T::Tail>::Result + 1 };
};

template<typename H>
struct TypeListSize<H, NullType> {
   enum { Result = 1 };
};

template<typename T>
struct TypeListSize<NullType, T> {
   enum { Result = 0 };
};

#define TYPELISTSIZE(L) TypeListSize<L::Head, L::Tail>::Result

#endif /* TL_H_ */
